#ifndef _PROCESSOR_H
#define _PROCESSOR_H

typedef enum
	{
	_PT_ChannelStatusReq	= 0x00,
	_PT_ChannelStatus		= 0x20,
	_PT_IRKeypress			= 0x22
	} _eKnownPacketTypes;

typedef enum
	{
	_SID_DCT		= 0x04,
	_SID_Sidecar	= 0x40
	} _eSenderID;

typedef enum
	{
	state_WaitPacketType,
	state_WaitLenHi,
	state_WaitLenLo,
	state_WaitSeq,
	state_WaitID,
	state_WaitPayload,
	state_WaitCRCHi,
	state_WaitCRCLo,
	state_WaitTerminator
	} _eState;

typedef struct
	{
	unsigned char	cPacketType;
	unsigned short	iLen;
	unsigned char	cSeq;
	unsigned char	cID;
	unsigned char	*cpPayload;
	unsigned short	iCRC;
	} _sPacket;

typedef struct
	{
	_eState			state;
	_sPacket		packet;
	int				payloadOffset;
	int				escReceived;
	int				showAllData;
	} _sProcessorInfo;

_sProcessorInfo *ProcessorInit( int showAllData );
void ProcessorCleanup( _sProcessorInfo *info );
void ProcessByte( _sProcessorInfo *info, unsigned char ch );
void ProcessPacket( _sProcessorInfo *info );

const char *GetKeyName( unsigned char ch );

void SenderIndent( unsigned char who, FILE *stream );
void IndentedPrintf( unsigned char who, FILE *stream, char *fmt, ... );


#endif // _PROCESSOR_H
